
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>图形上下文的矩阵操作(平移-缩放-旋转) / 憋错料</title>

    <meta name="description" content="图形上下文的矩阵操作(平移-缩放-旋转) 图形上下文的矩阵操作(旋转.缩放和平移) CGContextRotateCTM:图形上下文旋转,以上下文的原点(左上角)为基准 CGContextScaleCTM:图形上下文的缩放,以上下文的原点(左上角)为基准 CGContextTranslateCTM:图形上下文的平移,以上下文的原(左上角)点为基准 注意:一定要在添加路径之前进行设置 下面贴出swift版代码: 1 override func draw(_ rect: CGRect) { 2 let context = UIGraphic">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">图形上下文的矩阵操作(平移-缩放-旋转)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>图形上下文的矩阵操作(旋转、缩放和平移)</p>
<p>CGContextRotateCTM：图形上下文旋转，以上下文的原点(左上角)为基准</p>
<p>CGContextScaleCTM：图形上下文的缩放，以上下文的原点(左上角)为基准</p>
<p>CGContextTranslateCTM：图形上下文的平移，以上下文的原(左上角)点为基准</p>

<p><strong>注意：一定要在添加路径之前进行设置</strong></p>

<p>下面贴出swift版代码：</p>
<pre> 1 override func draw(_ rect: CGRect) {
 2         let context = UIGraphicsGetCurrentContext()
 3
 4         // MARK: - 注意：矩阵操作一定要在添加路径之前设置
 5
 6         // 旋转 - 逆时针旋转-M_PI_4(以原点为基准)
 7         // context?.rotate(by: CGFloat(-M_PI_4))
 8
 9         // 平移 - 往左下角(以原点为基准)
10         // context?.translateBy(x: 50, y: 50)
11
12         // 缩放 - 宽高各缩小一半(以原点为基准)
13         context?.scaleBy(x: 0.5, y: 0.5)
14
15         let borderPath = UIBezierPath(rect: rect)
16
17         let rectPath = UIBezierPath(rect: CGRect(x: 10, y: 10, width: 200, height: 200))
18
19         let circlePath = UIBezierPath(ovalIn: CGRect(x: 10, y: 210, width: 200, height: 200))
20
21         context?.addPath(borderPath.cgPath)
22         context?.addPath(rectPath.cgPath)
23         context?.addPath(circlePath.cgPath)
24
25         context?.setLineWidth(2)
26
27         context?.strokePath()
28     }</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-22 18:11:48 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/nbsp/" title="nbsp">nbsp</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.biecuoliao.com/tag/lin/" title="lin">lin</a>, <a href="https://www.biecuoliao.com/tag/border/" title="border">border</a>, <a href="https://www.biecuoliao.com/tag/swift/" title="swift">swift</a>, <a href="https://www.biecuoliao.com/tag/override/" title="override">override</a>, <a href="https://www.biecuoliao.com/tag/graphics/" title="graphics">graphics</a>, <a href="https://www.biecuoliao.com/tag/stroke/" title="stroke">stroke</a>, <a href="https://www.biecuoliao.com/tag/%e6%97%8b%e8%bd%ac/" title="旋转">旋转</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>图形上下文的矩阵操作(平移-缩放-旋转)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y2pxw3.html" rel="bookmark">Quartz2d  画饼状图 图形上下文栈 矩阵操作 裁剪圆角图片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				画饼状图 - (void)drawRect:(CGRect)rect { // Drawing code // 需求:根据sections的数据,绘制多个扇形 // 1.获取上下文(Layer Graphics Context) CGContextRef ctx = UIGraphicsGetCurrentContext(); // 2.根据sections的个数,计算扇形的起始和结束位置来画扇形 NSInteger count = self.sections.count; // 如果没有数据,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qEBVz3.html" rel="bookmark">WPF&sol;Silverlight中图形的平移&comma;缩放&comma;旋转&comma;倾斜变换演示</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:WPF/Silverlight中图形的平移,缩放,旋转,倾斜变换演示 为方便描述, 这里仅以正方形来做演示, 其他图形从略. 运行时效果图: XAML代码:// Transform.XAML &lt;Canvas Width=&quot;700&quot; Height=&quot;700&quot; xmlns=&quot;http://schemas.microsoft.com/winfx/2006/xaml/presentation&quot;  xmlns:x=&quot;http://sc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBY72v4.html" rel="bookmark">Quartz 2D 图形上下文栈  矩阵 裁剪</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Quartz 2D 图形上下文栈  矩阵 1 // 2 // DJVIew.m 3 // 图形上下文栈 4 // 5 // Created by zjj on 15/6/30. 6 // Copyright (c) 2015年 zjj. All rights reserved. 7 // 8 9 #import &quot;DJVIew.h&quot; 10 11 @implementation DJVIew 12 13 - (void)drawRect:(CGRect)rect 14 { 15 CGCo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02k8oz3.html" rel="bookmark">【转载】Unity中矩阵的平移、旋转、缩放</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				By:克森 简介 在这篇文章中,我们将会学到几个概念:平移矩阵.旋转矩阵.缩放矩阵.在学这几个基本概念的同时,我们会用到 Mesh(网格).数学运算.4x4矩阵的一些简单的操作.但由于克森也是新手,文章的严谨性可能不是很高,还请大神们多多指教. 创建项目 首先创建一个Unity工程,克森把他命名为“Matrix of China”(中国的矩阵),基本配置如下图所示: 为了便于查找,让我们在 Assets 目录下新建三个文件夹,分别命名为“Scripts”.“Shader”.“Materials”			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kNpGXM.html" rel="bookmark">矩阵的平移、旋转与缩放</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				世界坐标中的一个点乘以一个四维矩阵,可以实现平移,旋转和缩放等等. 平移就是,旋转和缩放就是(M分别是对应的旋转缩放矩阵) 当中为0时,是向量,为1时,是坐标. 平移, 旋转, 缩放,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NzXd64.html" rel="bookmark">&lbrack;C&num;&rsqb; Graphics平移缩放旋转</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[平移] private void btnTranslate_Click(object sender, EventArgs e) { Graphics graphics = this.CreateGraphics(); // 红色笔 Pen pen = new Pen(Color.Red, 5); Rectangle rect = new Rectangle(0, 0, 200, 50); // 用红色笔画矩形 graphics.DrawRectangle(pen, rect); // 向左平移			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N2Yy84.html" rel="bookmark">猫猫学IOS（三十二）UI之Quartz2D矩阵操作和图片剪切</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				猫猫分享,必须精品 原创文章,欢迎转载.转载请注明:翟乃玉的博客 地址:http://blog.csdn.net/u013357243?viewmode=contents 矩阵操作 矩阵操作:(旋转,缩放,平移) 通过矩阵操作,把画出来的东西进行形变 旋转操作 方法:CGContextRotateCTM(&lt;#CGContextRef c#&gt;, &lt;#CGFloat angle#&gt;)该接受两个参数(图形上下文,弧度) 注意点:设置矩阵操作必须要在添加图形之前,如果设置在添加图形之后的话			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02bLDB0.html" rel="bookmark">08 - 图形上下文状态栈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				*:first-child { margin-top: 0 !important; } body &gt; *:last-child { margin-bottom: 0 !important; } a { color: #4183C4; } a.absent { color: #cc0000; } a.anchor { display: block; padding-left: 30px; margin-left: -30px; cursor: pointer; position: absolute			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bZmmk0.html" rel="bookmark">OpenGL中平移、旋转、缩放矩阵堆栈操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在OpenGL中,图元的几何变换均为线性变换,通过矩阵变换实现.OpenGL中的坐标用齐次坐标表示,即(x,y,z)表示成(x',y',z',h),其中x=x'/h; y=y'/h; z=z'/h. 通常h取1. 比如空间中的点(2,3,4),在OpenGL中将表示成(2,3,4,1). 齐次坐标表示方式适合于矩阵运算,也很方便地表示了无穷远的点,比如(1,0,0,0)就表示x轴上无穷远的点,因为1/0是无穷大,这里约定0/0=0. 例:点(1,1,1)将该向量平移变换(2,3,4)个单位,得到			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aYjE0.html" rel="bookmark" class="title">eclipise快捷键，留给以后备用</a>
					<div>
						快捷键无效解决办法: 1.考虑是否被其他应用占用,如QQ,QQ音乐,千千动听等 2.在eclispe查看是否被修改:Window-&gt;Preferences-&gt;General-&gt;Key ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/gMWqda3.html" rel="bookmark" class="title">二维数据名作形参</a>
					<div>
						之前帮同学调一个程序的时候遇到的,把二维数据改为全局变量,不通过参数传递就没问题了,否则程序崩溃. 细究一下,二维数据名用于形参时需要注意哪些方面. 测试程序如下: #include&lt;stdio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q3qgEpM.html" rel="bookmark" class="title">服务器监控cacti</a>
					<div>
						第九章:服务器监控系统cacti 防伪码:海阔天空 前言:在企业网络运维过程中,管理员必须时刻关注服务器的运行状态,如CPU.内存.磁盘空间使用情况等.为了能够及时的发现问题,尽量减少故障的发生.当网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0RX2j4.html" rel="bookmark" class="title">《Android深度探索》&lpar;卷1&rpar;HAL与驱动开发 第九章心得体会</a>
					<div>
						本章主要学习了硬件抽象层:HAL. Android的硬件抽象层,简单来说,就是对Linux内核驱动程序的封装,向上提供接口,屏蔽低层的实现细节.也就是说,把对硬件的支持分成了两层,一层放在用户空间(U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDL8P0.html" rel="bookmark" class="title">NSMutableString&comma;可变字符串&comma;拼接&comma;删除&comma;插入&comma;替换</a>
					<div>
						&lt;span style=&quot;font-size:18px;&quot;&gt; NSMutableString *str = [NSMutableString stringWithFor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wr2v10.html" rel="bookmark" class="title">【bzoj3924】&lbrack;Zjoi2015&rsqb;幻想乡战略游戏    动态树分治</a>
					<div>
						题目描述 傲娇少女幽香正在玩一个非常有趣的战略类游戏,本来这个游戏的地图其实还不算太大,幽香还能管得过来,但是不知道为什么现在的网游厂商把游戏的地图越做越大,以至于幽香一眼根本看不过来,更别说和别人打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVw8Ww0.html" rel="bookmark" class="title">js中关于array的常用方法</a>
					<div>
						最近总结了一些关于array中的常用方法, 其中大部分的方法来自于&lt;JavaScript框架设计&gt;这本书, 如果有更好的方法,或者有关于string的别的常用的方法,希望大家不吝赐教. 直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7lxb4.html" rel="bookmark" class="title">java基础：this关键字</a>
					<div>
						一:使用场景 (1)在一个构造方法中,通过this关键字调用所在类中的另一个构造方法. (2)在一个实例方法内,局部变量或参数与实例变量名称相同,编译口器无法区分变量,这时要用this关键字. (3) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62EGWM.html" rel="bookmark" class="title">jQuery comet</a>
					<div>
						下面程序是例用从数据端推送信息,原理是每隔10秒读取一下data.txt文件,看有木有新的数据输入,如果有,则alert文件内容. hmtl代码是 &lt;!DOCTYPE html&gt; &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aOgzP4.html" rel="bookmark" class="title">window下python 扩展库安装 使用第三方镜像源</a>
					<div>
						0.前言 由于python的官方镜像位于国外,若使用pip或者easy_install安装第三方插件时或许会被限制,甚至连easy_install或pip也无法安装,例如在windows环境下运行ez ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qawqP3.html" rel="bookmark" class="title">机器学习-监督学习应用：梯度下降</a>
					<div>
						回归与梯度下降: 回归在数学上来说是给定一个点集,能够用一条曲线去拟合之,如果这个曲线是一条直线,那就被称为线性回归,如果曲线是一条二次曲线,就被称为二次回归,回归还有很多的变种,如locally w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWbxLM.html" rel="bookmark" class="title">Problem E&colon; 可变长数组</a>
					<div>
						Problem E: 可变长数组 Time Limit: 1 Sec  Memory Limit: 128 MBSubmit: 472  Solved: 368[Submit][Status][Web ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mA6k0.html" rel="bookmark" class="title">retrofit2 上传图片</a>
					<div>
						直接上代码 接口请求代码 NewResultApi.modifyUserInfo(userModel.getUid(), userModel.getToken(), sex, intro, name, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wEKzQM.html" rel="bookmark" class="title">60条知乎神回复，大部分都比较有道理</a>
					<div>
						转载:http://news.timedg.com/2015-07/27/20184368.shtml1.问:你收到的最雷的表白语是什么?知友:程冬冬做我女朋友行不行,行就行,不行我再想想办法. 2. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDreY73.html" rel="bookmark" class="title">【Javascript学习】语言基础</a>
					<div>
						数据类型 javascript数据类型分为两种:基本类型与对象类型 基本类型:数字.字符串.布尔值.null.undefined其中null与undefined代表了各自特殊类型的唯一成员 对象类型: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNLA64.html" rel="bookmark" class="title">TIME&lowbar;WAIT状态的连接过多导致系统端口资源耗尽问题&lpar;2&rpar;</a>
					<div>
						继上次解决完mysql连接过多,导致的TIME_WAIT进程过多问题之后,最近这个现象再一次出现,并且依然和之前一样严重.只不过这次出现问题的mysql 服务跟上次不一样,上一次主要是mysql ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8vdeM.html" rel="bookmark" class="title">IOS本地化应用</a>
					<div>
						BK项目已完成7788,在项目的后期需要被翻译成多国语言版.为了适应全球多个国家使用多个存储. 应用本地化是分别对字符串.图片和 xib 或 storyboard 文件本地化,而传统的做法是对 xib ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Onz9r0.html" rel="bookmark" class="title">Lua输入输出库</a>
					<div>
						1.简单模型 )1.io.write函数: 函数模型为io.write(...) )2.io.read函数: io.read(*all) 读取当前输入的整个文件 io.read(*line) 读取下一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWx8K0.html" rel="bookmark" class="title">机器学习的5种&OpenCurlyDoubleQuote;兵法&amp;quot&semi;</a>
					<div>
						大数据文摘作品,欢迎个人转发朋友圈,自媒体.媒体.机构转载务必申请授权,后台留言“机构名称+转载”,申请过授权的不必再次申请,只要按约定转载即可. 作者:Jason Brownlee 译者:Clair ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBDEp0.html" rel="bookmark" class="title">Kwickserver</a>
					<div>
						欢迎来到Kwickserver的主页 Kwickserver是什么? Kwickserver是一个易于安装的和易于使用的服务器应用程序,从CD安装在PC兼容的硬件和坚持webinterface配置和管 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
